/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.06.29.
 * Time: 13:08
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace Noise.Controls
{
	/// <summary>
	/// Description of DataListView.
	/// </summary>
	public class DataListView : ListView
	{
		public DataListView() : base() { }

		
		[EditorBrowsableAttribute()]
		protected override void OnCreateControl()
		{
			base.OnCreateControl();
			this.View = View.Details;
			this.GridLines = true;
			this.Scrollable = true;
		}
		
		public void AddItems(int count, int subItems)
		{
			if (count < 1) return;
			ListViewItem[] items = new ListViewItem[count];
			
			
			for (int i = 0; i < count; i++) {
				items[i] = new ListViewItem(new string[subItems]);
			}
			
			this.Items.AddRange(items);
		}
		
		protected override void OnResize(EventArgs e)
		{
			WindowsAPI.ShowScrollBar(this.Handle, 3, false);
			base.OnResize(e);
		}
		
		
	}
}
